#!/usr/bin/perl
# $Id: crond_checker.pl
# Copyright 2006-2019 SOLARSPEED.NET. All rights reserved.
#
# Description:
#
# Script that runs through a cronjob, tests if all running VPS's have crond running.
# If not, then it's tried to start crond via /sbin/service, which even on Systemd enabled
# CTs should bring crond back up. Provided there is a service with that name.
#

if (-f "/proc/vz/veinfo") {
    $running_vps_present = `LC_ALL=C /usr/sbin/vzlist -a --no-header | grep -v stopped | grep -v mounted | wc -l`;
    chomp($running_vps_present);

    if ($running_vps_present gt "0") {

        # Get VZLIST:
        $vzlist_raw = `LC_ALL=C /usr/sbin/vzlist --no-header --output veid |  awk '{print \$1}'`;
        @vzlist = split("\n",$vzlist_raw);

        foreach my $x (@vzlist) {
            if ($x ne '') {

                # Check if VPS is running:
                $vps_status = `LC_ALL=C /usr/sbin/vzlist --no-header --output status $x|grep running|wc -l`;
                chomp($vps_status);

                # If VPS is running ...
                if ($vps_status eq "1") {

                    $report = '0';
                    $report = `LC_ALL=C /usr/sbin/vzctl exec $x ps axf|grep crond|wc -l`;
                    chomp($report);

                    if ($report eq "0") {
                        print "Crond is stopped in CT $x ... restarting it.\n";
                        # Restart CT's Crond:
                        $run = `LC_ALL=C /usr/sbin/vzctl exec $x "/sbin/service crond restart >/dev/null 2>&1 || :"`;
                    }
                    else {
                        print "Crond is running in CT $x \n";
                    }
                }
            }
        }
    }
}

exit;
